
local addon, ns = ...
local cfg = ns.cfg

local lib = CreateFrame("Frame")  

local _, playerClass = UnitClass("player")

oUF.colors.power['MANA'] = {0.0, 0.56, 1.0}
oUF.colors.power['RAGE'] = {1.0,0,0}
oUF.colors.power['FOCUS'] = {1.0,0.75,0.25}
oUF.colors.power['ENERGY'] = {0.9, 0.7, 0.1}
oUF.colors.power['RUNIC_POWER'] = {0.44,0.44,0.44}
oUF.colors.power['AMMOSLOT'] = {0.8,0.6,0}
oUF.colors.power['FUEL'] = {0,0.55,0.5}
oUF.colors.power['POWER_TYPE_STEAM'] = {0.55,0.57,0.61}
oUF.colors.power['POWER_TYPE_PYRITE'] = {0.6,0.09,0.17}
oUF.colors.power['POWER_TYPE_HEAT'] = {0.9,0.45,0.1}
oUF.colors.power['POWER_TYPE_OOZE'] = {0.1,0.1,0.9}
oUF.colors.power['POWER_TYPE_BLOOD_POWER'] = {0.9,0.1,0.1}

local _, pType = UnitPowerType("player")
local pcolor = oUF.colors.power[pType] or {.3,.45,.65}
oUF.colors.runes = {{196/255, 30/255, 58/255};{173/255, 217/255, 25/255};{35/255, 127/255, 255/255};{178/255, 53/255, 240/255};}
    

--status bar filling fix (from oUF_Mono)
local fixStatusbar = function(b)
   b:GetStatusBarTexture():SetHorizTile(false)
   b:GetStatusBarTexture():SetVertTile(false)
end


--right click menu------
lib.spawnMenu = function(self)

   local dropdown = CreateFrame("Frame", "MyAddOnUnitDropDownMenu", UIParent, "UIDropDownMenuTemplate")
   UIDropDownMenu_Initialize(dropdown, function(self)
      local unit = self:GetParent().unit
      if not unit then return end

      local menu, name, id
      if UnitIsUnit(unit, "player") then
         menu = "SELF"
      elseif UnitIsUnit(unit, "vehicle") then
         menu = "VEHICLE"
      elseif UnitIsUnit(unit, "pet") then
         menu = "PET"
      elseif UnitIsPlayer(unit) then
         id = UnitInRaid(unit)
            if id then
               menu = "RAID_PLAYER"
               name = GetRaidRosterInfo(id)
            elseif UnitInParty(unit) then
               menu = "PARTY"
            else
               menu = "PLAYER"
            end
      else
         menu = "TARGET"
         name = RAID_TARGET_ICON
      end

      if menu then
         UnitPopup_ShowMenu(self, menu, unit, name, id)
      end
   end, "MENU")

   dropdown:SetParent(self)
   ToggleDropDownMenu(1, nil, dropdown, "cursor", 0, 0)
	
   --remove SET_FOCUS & CLEAR_FOCUS from menu, to prevent errors
   do 
      for k,v in pairs(UnitPopupMenus) do
         for x,y in pairs(UnitPopupMenus[k]) do
            if y == "SET_FOCUS" then
               table.remove(UnitPopupMenus[k],x)
            elseif y == "CLEAR_FOCUS" then
               table.remove(UnitPopupMenus[k],x)
            end
         end
      end
   end

end	

  
lib.gen_hpbar = function(f, unit, min, max)

   local s = CreateFrame("StatusBar", nil, f)
   s:SetOrientation("VERTICAL")	
   s:SetPoint("TOP",0,0)
   s:SetFrameLevel(4)	
	
   if f.mystyle == "player" then
      s:SetStatusBarTexture(cfg.media.player_hp)
      s:SetSize(200, 400)
   elseif f.mystyle == "target" then
      s:SetStatusBarTexture(cfg.media.target_hp)
      s:SetSize(200, 400)
	--Health:SetReverseFill(true)
	--Health.PostUpdate = function(Health, unit, min, max)
	--Health:SetValue(max - Health:GetValue())
	--end
   end

   f.Health = s
end
  

lib.gen_ppbar = function(f)

   local s = CreateFrame("StatusBar", nil, f)
   if f.mystyle== "player" then
      s:SetStatusBarTexture(cfg.media.player_mp)
      s:SetOrientation("VERTICAL")	
      s:SetSize(200, 350)
      s:SetPoint("BOTTOM", f, "BOTTOM", 6, -40)
   elseif f.mystyle == "target" then
      s:SetStatusBarTexture(cfg.media.target_mp)
      s:SetOrientation("VERTICAL")	
      s:SetSize(200, 350)
      s:SetPoint("BOTTOM", f, "BOTTOM", -6, -40)
      s:SetFrameLevel(1)
   end

   f.Power = s
end
  

lib.gen_RaidMark = function(f)

   local h = CreateFrame("Frame", nil, f)
   h:SetAllPoints(f)
   h:SetFrameLevel(10)
   h:SetAlpha(0.8)

   local ri = h:CreateTexture(nil,'OVERLAY',h)
   ri:SetPoint("CENTER", f.Health, "BOTTOM", -8, 18)
   ri:SetTexture([[Interface\Addons\oUF_DHUD\media\raidicons.blp]])
   ri:SetSize(24, 24)
      f.RaidTargetIndicator = ri
end

ns.lib = lib